<template>
  <!--  <el-dialog title="收货地址" :visible.sync="dialogFormVisible">-->
  <el-container>
    <el-header style="width: 100%; height: 80px;font-size: 12px">

      <el-form :inline="true"  label-width="65px"  label-position="left">
        <el-row>

          <el-col :span="22">
            <el-form-item label="班组:">
<!--              <el-input v-model="request.resourcesCode" type="search" placeholder="班组" ></el-input>-->
              <el-select v-model="request.resourcesCode" placeholder="班组" clearable  >
              <el-option
                v-for="item in this.dictData.resourcesCodes"
                :key="item.resourcesCode"
                :label="item.resourcesCode"
                :value="item.resourcesCode"
              >
              </el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="作业区:">
<!--              <el-input v-model="request.zyq" type="search" placeholder="作业区" ></el-input>-->
              <el-select v-model="request.zyq" placeholder="作业区" clearable  >
                <el-option
                  v-for="item in this.dictData.zyqs"
                  :key="item.zyq"
                  :label="item.zyq"
                  :value="item.zyq"
                >
                </el-option>
              </el-select>

            </el-form-item>
            <el-form-item label="名称:">
              <el-input v-model="request.userName" type="search" placeholder="名称" ></el-input>
            </el-form-item>

          </el-col>
          <el-col :span="2">
            <el-form-item style="float: right" >
              <el-button type="success" @click="initList">查询</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="14">
            <el-select v-model="inParam.zt" placeholder="状态" clearable  >
              <el-option
                v-for="item in this.dictData.kwxxs"
                :key="item.bm"
                :label="item.bmsm"
                :value="item.bm"
              >
              </el-option>
            </el-select>
            <el-input v-model="inParam.rqfw" placeholder="日期范围" clearable style="width: 200px" />
            <el-button type="info" @click="plClick">批量</el-button>
          </el-col>
          <el-col :span="10" >
            <el-form-item style="float: right" >

              <el-button
                type="success"
                @click="toolbarButtonClickEvent('save')"
              >保存</el-button>
              <el-button type="success" @click="toolbarButtonClickEvent('insert')">添加</el-button>
              <el-button
                type="danger"
                @click="toolbarButtonClickEvent('delete')"
              >删除
              </el-button>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-header>
    <el-container  style="padding-top: 0px">
      <el-container>
        <el-main>
          <div class="mytable">
            <vxe-grid
              id="id"
              ref="xGrid"
              border
              resizable
              keep-source
              :align="'center'"
              :height="height"
              :auto-resize="true"
              :columns="tableColumn"
              highlight-current-row
              :data="list"
              :custom-config="{ storage: true }"
              :edit-config="{ trigger: 'click', mode: 'cell', showStatus: true}"
              highlight-hover-row

              :scroll-y="{enabled: true}"
              show-overflow
              show-header-overflow

            />
          </div>


        </el-main>
      </el-container>
    </el-container>
  </el-container>
</template>

<script>

import {
  getTpBase
} from '@/api/fd/base'
import { mapGetters } from 'vuex'
import XEUtils from 'xe-utils'
import {null2str} from "@/utils/rpkj";
import {del, getBzryDel, getBzryInsert, getBzryList, getBzryUpdate, getryBase} from "@/api/sjzx/bzzGL";
export default {
  name:'xqdwcjcd',
  data() {
    return {
      request: {
        resourcesCode:'',
        zrq:'',
        userName:''

      },inParam:{
        rqfw:'',
        zt:""
      },
      list: [],
      deptList: [],
      clickList: [],

      dictData:{},
      height: '500px',

      tableColumn: [
        { type: 'checkbox', width: 50 ,
        },
        { type: 'seq', width: 40, title: '序号' },
        {
          field: 'userCode',
          title: '人员编码',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'userName',
          title: '人员姓名',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'resourcesCode',editRender: { name: 'input' },
          title: '班组',
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'zyq',
          title: '作业区',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'position',
          title: '人员职务',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },

        {
          field: 'yzt',
          title: '原状态',
          width: 120, formatter: ['dictFormat','PBBM'],
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'zt',
          title: '状态',
          width: 120,formatter: ['dictFormat','PBBM'],
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
    //     editRender: {
    //   name: '$select', options: [],
    //     optionProps: {value: 'bm', label: 'bmsm'},
    //   props: {clearable: true}
    // , events: {change: this.selectChange}
    // },
        {
          field: 'rqfw',
          title: '日期范围',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },

        {
          field: 'xgry',
          title: '修改人员',
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'xgrq',
          title: '修改日期',
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },

      ]
    }
  },
  computed: {
    ...mapGetters(['name', 'bmbm','apbm'])
  },
  created() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.initBase()
    if(this.apbm==='P30000'){
      this.request.dwbm='P30000'
      this.flag=true;
    }else{
      this.flag=false;
    }

  },
  methods: {






    initBase(){
      getryBase({}).then(res=>{
        this.dictData = res.data
        console.log(this.dictData)
        const xGrid = this.$refs.xGrid

        const zt = xGrid.getColumnByField('zt')
        const yzt = xGrid.getColumnByField('yzt')
        zt.editRender.options = res.data.kwxxs
        yzt.editRender.options = res.data.kwxxs

      })
    },
    initList() {
      getBzryList(this.request).then((res) => {
        this.list = res.data
        if (this.$refs.xGrid) {
          this.$refs.xGrid.loadData(this.list)
        }

      })
    },

    plClick(){
      let selectRecords = this.$refs.xGrid.getCheckboxRecords()
      if(selectRecords.length>0){
        for(let i = 0; i < selectRecords.length; i++) {
          if(this.inParam.zt !==''){
            selectRecords[i]. yzt= selectRecords[i]. zt
            selectRecords[i]. zt= this.inParam.zt

          }
          if(this.inParam.rqfw !==''){
            selectRecords[i].rqfw = this.inParam.rqfw
          }


        }
        this.$refs.xGrid.updateData(this.list)
      }

    },


    selectChange(row) {
      this.$refs.xGrid.clearActived() // 清除单元格激活状态
      this.$refs.xGrid.setActiveCell(row.row, row.column.property) // 设置单元格为激活状态
      null2str(row.row)
    },
    getHeight() {
      this.height = window.innerHeight - 190
    },
    toolbarButtonClickEvent(code) {
      const {
        insertRecords,
        removeRecords,
        updateRecords
      } = this.$refs.xGrid.getRecordset()
      switch (code) {
        case 'insert':
          if(this.request.dwbm==='' ||this.request.dwbm===null){
            this.$message({ message: '请选择需求单位！', type: 'warning' })
            return
          }
          this.$refs.xGrid.insertAt({

          }, -1).then(({ row }) => {
            this.$refs.xGrid.setActiveRow(row)
          })
          break
        case 'delete':
          this.$confirm('删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then((type) => {
            this.$refs.xGrid.removeCheckboxRow()
          })
          break
        case 'save':


          if (removeRecords.length !== 0) {
            getBzryDel(removeRecords).then((response) => {
              if (response.success) {
                for (let i = 0; i < this.list.length; i++) {
                  if (removeRecords.indexOf(this.list[i]) !== -1) {
                    this.list.splice(i, 1)
                    i--
                  }
                }
                this.$message({ message: '保存成功！', type: 'success' })
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())

              }
            })
          }



          if (updateRecords.length !== 0) {
            getBzryUpdate(updateRecords).then((response) => {
              if (response.success) {
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({message: '保存成功！', type: 'success'})
              }
            })
          }
          if (insertRecords.length !== 0) {
            getBzryInsert(insertRecords).then((response) => {
              if (response.success) {
                this.list = this.list.concat(insertRecords)
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({ message: '保存成功！', type: 'success' })
              }
            })
          }
          this.$message(
            `新增 ${insertRecords.length} 条，删除 ${removeRecords.length} 条，更新 ${updateRecords.length} 条`
          )
          this.clickList = []
          break
      }
    }
  }
}
</script>
<style lang="scss" scoped >

.el-header{margin:0;padding: 5px;height:auto;
  .el-input{
    width: 140px;
  }
  .el-select{
    width: 140px;
  }

}
.el-container{padding: 0;margin:0;}
.el-main{padding: 0;}
.el-col{padding: 0;height: 32px;}
.el-aside{background: #fff;padding: 0}
.el-container{padding: 0}
.el-row {}
.el-row:last-child {margin-bottom: 0; }

.tableStyles{
  background: #0a76a4;
}

.my-dropdown {
  width: 400px;
  height: 400px;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);
  font-size: 12px;

}
.mytable1{

}
.borderClass{

}
.vxe-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.el-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.keyword-lighten {
  color: #000;
  background-color: #FFFF00;
}

.vxe-textarea--inner {
  line-height: inherit;
}
.el-form-item__label-wrap {
  margin-left: 0px !important;
  float: left;
}
.fontClass{
  font-size: 12px;
  font-weight: bold;
}


</style>
